io_getevents(2)

NAME
io_getevents - Read resulting events from io requests

SYNOPSIS
#include <errno.h>

#include <libaio.h>

struct iocb {
	void		*data;
	unsigned	key;
	short		aio_lio_opcode;
	short		aio_reqprio;
	int		aio_fildes;
};

struct io_event {
        unsigned        PADDED(data, __pad1);
        unsigned        PADDED(obj,  __pad2);
        unsigned        PADDED(res,  __pad3);
        unsigned        PADDED(res2, __pad4);
};

int io_getevents(io_context_t ctx,  long nr, struct io_event *events[], struct timespec *timeout);

DESCRIPTION
Attempts to read up to nr events from the completion queue for the aio_context specified by ctx.

RETURN VALUES
May return 0 if no events are available and the timeout specified by when has elapsed, where when == NULL specifies an infinite timeout. Note that the timeout pointed to by when is relative and will be updated if not NULL and the operation blocks. Will fail with ENOSYS if not implemented.

ERRORS

EINVAL
    if ctx_id is invalid, if min_nr is out of range, if nr is out of range, if when is out of range.

EFAULT
    if any of the memory specified to is invalid.

SEE ALSO
io(3), io_cancel(3), io_fsync(3), io_prep_fsync(3), io_prep_pread(3), io_prep_pwrite(3), io_queue_init(3), io_queue_release(3), io_queue_run(3), io_queue_wait(3), io_set_callback(3), io_submit(3), errno(3)